// this could be a support module on its own lol

function Scratch::neatifyNumber(%str) {
	for(%i=strLen(%str);%i>=0;%i--) %ret = getSubStr(%str, %i, 1) @ ((strLen(%ret) % 4) == 0 ? "," : "") @ %ret;
	%ret = strReplace(trim(strReplace(%ret, "\,", " ")), " " ,",");
	return %ret;
}

function Scratch::neatifyTimeFormat(%str) {
	%time = strReplace(getWord(%str, 2), ":", " ");
	%date = getWord(%str, 0);
	%hour = atoi(getWord(%time, 0));
	%min  = atoi(getWord(%time, 1));
	if(strLen(%min) == 1) %min = "0" @ %min;
	// Seconds dont matter
	if(%hour > 12) { %hour -= 12; %prefix = "PM"; } else %prefix = "AM";
	return %date SPC %hour @ ":" @ %min SPC %prefix;
}

function Scratch::isModTimeGreater(%strOne, %strTwo) {
	%dateOne    = strReplace(getWord(%strOne, 0), "/", " ");
	%dateTwo    = strReplace(getWord(%strTwo, 0), "/", " ");
	%timeOne    = strReplace(getWord(%strOne, 2), ":", " ");
	%timeTwo    = strReplace(getWord(%strTwo, 2), ":", " ");
	%dateBigger = getWord(%dateOne, 2) > getWord(%dateOne, 2);
	if(getWord(%dateOne, 0) == getWord(%dateTwo, 0) && !%dateBigger) %dateBigger = getWord(%dateOne, 1) > getWord(%dateOne, 1);
	if(getWord(%dateOne, 0) == getWord(%dateTwo, 0) && getWord(%dateOne, 1) == getWord(%dateTwo, 1) && !%dateBigger) %dateBigger = getWord(%dateOne, 0) > getWord(%dateOne, 0);
	%timeBigger = getWord(%timeOne, 0) > getWord(%timeTwo, 0);
	if(getWord(%timeOne, 0) == getWord(%timeTwo, 0) && !%timeBigger) %timeBigger = getWord(%timeOne, 1) > getWord(%timeTwo, 1);
	if(getWord(%timeOne, 0) == getWord(%timeTwo, 0) && getWord(%timeOne, 1) == getWord(%timeTwo, 1) && !%timeBigger) %timeBigger = getWord(%timeOne, 2) > getWord(%timeTwo, 2);
	return (%dateBigger || %timeBigger);
}

function Scratch::getNeatFileSize(%size) {
	%pre = "B";
	if(%size >= 1024) { %pre = "KB"; %size /= 1024; }
	if(%size >= 1024) { %pre = "MB"; %size /= 1024; }
	if(%size >= 1024) { %pre = "GB"; %size /= 1024; }
	if(%size >= 1024) { %pre = "TB"; %size /= 1024; }
	return Scratch::neatifyNumber(mFloor(%size)) SPC %pre;
}

function ScratchGui::openDirectorySelector(%this, %callBack, %OKBtnLabel, %fileTypes) {
	$CACHE::Scratch::DirectorySelector::CallBack = %callBack;
	Canvas.pushDialog(ScratchFileSelector);
	//%win  = Scratch_FileSelector;
	//%winS = Scratch_MainWindow.getLeft()+((Scratch_MainWindow.getWidth()/2)-(%win.getWidth()/2)) SPC Scratch_MainWindow.getTop()+((Scratch_MainWindow.getHeight()/2)-(%win.getHeight()/2));
	//%win.resize(getWord(%winS, 0), getWord(%winS, 1), %win.getWidth(), %win.getHeight());
	//%win.setVisible(1);
	//%this.pushToBack(%win);
	Scratch::fileSel_buildDirList();
	Scratch_DirSelector_OKButton.setText((%OKBtnLabel $= "" ? "OK" : %OKBtnLabel));
	Scratch_DirSelector_FileType.clear();
	$CACHE::Scratch::DirectorySelector::FileTypes   = (%fileTypes $= "" ? "any" : %fileTypes);
	$CACHE::Scratch::DirectorySelector::CurrFileType = 0;
	for(%i=0;%i<getFieldCount(%fileTypes);%i++) {
		%text = removeWord(getField(%fileTypes, %i), 0);
		Scratch_DirSelector_FileType.add(%text, %i);
	}
	Scratch_DirSelector_FileType.setSelected(0);
	if(%fileTypes $= "") {
		Scratch_DirSelector_FileType.setValue("All Files");
		Scratch_DirSelector_FileType.add("All Files", 0);
	}
	if($CACHE::Scratch::FileSelector::Path $= "") $CACHE::Scratch::FileSelector::Path = "Add-Ons";
	ScratchFileSelectorHistorySO.historyIdx = 0;
	ScratchFileSelectorHistorySO.empty();
	ScratchGui.selectDirectory($CACHE::Scratch::FileSelector::Path);
}

function Scratch_DirSelector_FileType::onSelect(%this, %Id, %text) {
	$CACHE::Scratch::DirectorySelector::CurrFileType = %Id;
	ScratchGui.selectDirectory($CACHE::Scratch::FileSelector::Path);
}

function ScratchGui::selectDirectory(%this, %dir, %doNotRecordHistory) {
	%acceptedTypes  = getWord(getField($CACHE::Scratch::DirectorySelector::FileTypes, $CACHE::Scratch::DirectorySelector::CurrFileType), 0);
	%format[".txt"] = "Text Document";
	%format[".cs"]  = "Torque Script";
	%format[".sws"] = "Scratch Workspace";
	if(%dir $= "") {
		%grp = Scratch_FileSelector_DirectoryList;
		%dir = %grp.getRowTextById(%grp.getSelectedId());
		%dir = getField(%dir, 1);
	}
	%ourPath = %dir;
	Scratch_DirSelector_Directory.setValue(%dir);
	$CACHE::Scratch::FileSelector::Path = %ourPath;
	if(!%doNotRecordHistory) {
		ScratchFileSelectorHistorySO.pushBack(%dir);
		ScratchFileSelectorHistorySO.historyIdx++;
	}
	%group   = Scratch_FileSelector_FileList;
	%group.clear();
	%group.addRow(-1, "A This row will be hidden by sort buttons.");
	%pattern = %dir @ "/*.*";
	for(%file=findFirstFile(%pattern);%file !$= "";%file=findNextFile(%pattern)) {
		%path    = filePath(%file);
		%modTime = Scratch::neatifyTimeFormat(getFileModifiedTime(%file));
		if(%path !$= %ourPath) {
			%disp = getSubStr(%path, strLen(%ourPath)+1, strLen(%path));
			if(strIPos(%disp, "/") != -1) continue;
			if(%got[getStringCRC(%path)]) {
				%oldModTime = getField(%group.getRowTextById(getStringCRC(%path)), 1);
				if(Scratch::isModTimeGreater(%modTime, %oldModTime)) {
					%group.setRowById(getStringCRC(%path), %disp TAB %modTime TAB "File Folder");
				}
				continue;
			}
			%got[getStringCRC(%path)] = 1;
			%group.addRow(getStringCRC(%path), %disp TAB %modTime TAB "File Folder");
			continue;
		}
		if(%acceptedTypes !$= "any" && strIPos(%acceptedTypes, "_" @ fileExt(%file) @ "_") == -1) continue;
		if((%fmt = %format[fileExt(%file)]) $= "") %fmt = strUpr(getSubStr(fileExt(%file), 1, strLen(fileExt(%file)))) SPC "File";
		%group.addRow(getStringCRC(fileBase(%file)), fileName(%file) TAB %modTime TAB %fmt TAB Scratch::getNeatFileSize(getFileLength(%file)));
	}
	%group.sort("2", 1);
}

function Scratch::fileSel_Up() {
	%ourPath = $CACHE::Scratch::FileSelector::Path;
	if(strIPos(%ourPath, "/") == -1) return;
	%ourPath = getSubStr(%ourPath, 0, striPos_Last(%ourPath, "/"));
	ScratchGui.selectDirectory(%ourPath);
}

function Scratch::fileSel_Back() {
	if(ScratchFileSelectorHistorySO.historyIdx == 0) return;
	ScratchFileSelectorHistorySO.historyIdx--;
	%dir = ScratchFileSelectorHistorySO.at(ScratchFileSelectorHistorySO.historyIdx);
	ScratchGui.selectDirectory(%dir, 1);
	%dirList = Scratch_FileSelector_DirectoryList;
	%oldCmd = %dirList.command;
	%dirList.command = "";
	%dirList.setSelectedById(%dirList.findTextIndex(%dir));
	%dirList.command = %oldCmd;
}

function Scratch::fileSel_Forward() {
	if(ScratchFileSelectorHistorySO.historyIdx == ScratchFileSelectorHistorySO.size()) return;
	ScratchFileSelectorHistorySO.historyIdx++;
	%dir = ScratchFileSelectorHistorySO.at(ScratchFileSelectorHistorySO.historyIdx);
	ScratchGui.selectDirectory(%dir, 1);
	%dirList = Scratch_FileSelector_DirectoryList;
	%oldCmd = %dirList.command;
	%dirList.command = "";
	%dirList.setSelectedById(%dirList.findTextIndex(%dir));
	%dirList.command = %oldCmd;
}

function Scratch::fileSel_Refresh() {
	setModPaths(getModPaths());
	ScratchGui.selectDirectory($CACHE::Scratch::FileSelector::Path);
}

function Scratch::fileSel_selectFile() {
	%ourPath  = $CACHE::Scratch::FileSelector::Path;
	%group    = Scratch_FileSelector_FileList;
	%fileName = getField(%group.getRowTextById(%group.getSelectedId()), 0);
	%fileType = getField(%group.getRowTextById(%group.getSelectedId()), 2);
	if(%fileType $= "File Folder") {
		ScratchGui.selectDirectory($CACHE::Scratch::FileSelector::Path @ "/" @ %fileName);
		Scratch_DirSelector_Filename.setValue("");
	} else {
		if(%fileName $= Scratch_DirSelector_Filename.getValue()) ScratchGui.doDirectorySelectorCallback();
		Scratch_DirSelector_Filename.setValue(%fileName);
	}
}


function Scratch::fileSel_buildDirList() {
	if(!isObject(%obj = ScratchDirectoryListBuilderCache)) %obj = new ScriptObject(ScratchDirectoryListBuilderCache) { class = "ArrayObject"; };
	%group   = Scratch_FileSelector_DirectoryList;
	%dir     = $CACHE::Scratch::FileSelector::Path;
	%group.clear();
	%pattern = "*.*";
	for(%file=findFirstFile(%pattern);%file !$= "";%file=findNextFile(%pattern)) {
		%path       = filePath(%file);
		%childPath  = getSubStr(%path, 0, (strIPos(%path, "/") == -1 ? 0 : strIPos_Last(%path, "/")));
		%name       = getSubStr(%path, (strIPos(%path, "/") == -1 ? 0 : strIPos_Last(%path, "/")+1), strLen(%path));
		%indentSize = mAbs(strLen(stripChars(%childPath, "/"))-strLen(%childPath));
		%CRC        = getStringCRC(%path);
		%ChildCRC   = getStringCRC(%childPath);
		if(%got[%CRC]) continue;
		%got[%CRC] = 1;
		%group.addRow(%CRC, Scratch::indent(%currentIndentSize) @ %path TAB %path);
	}
	return;
	while(%pattern !$= "") {
		if(%dbg++ >= 500) { echo("bad"); break; }
		%currentPattern    = getWord(%pattern, 0);
		%currentChildPath  = getSubStr(%currentPattern, 0, (strIPos(%currentPattern, "/") == -1 ? 0 : strIPos_Last(%currentPattern, "/")));
		%currentIndentSize = mAbs(strLen(stripChars(%currentChildPath, "/"))-strLen(%currentChildPath));
		%currentName       = getSubStr(%currentPattern, (strIPos(%currentPattern, "/") == -1 ? 0 : strIPos_Last(%currentPattern, "/")+1), strLen(%currentPattern));
		%CRC               = getStringCRC(%currentPattern);
		%CurrentChildCRC   = getStringCRC(%currentChildPath);
		if(%currentPattern $= "*.*") %currentPattern = "";
		else %group.addRow(%CRC, Scratch::indent(%currentIndentSize) @ ">" @ %currentName TAB %currentPattern);
		for(%file=findFirstFile(%currentPattern @ "*.*");%file !$= "";%file=findNextFile(%currentPattern @ "*.*")) {
			%path       = filePath(%file);
			%childPath  = getSubStr(%path, 0, (strIPos(%path, "/") == -1 ? 0 : strIPos_Last(%path, "/")));
			%name       = getSubStr(%path, (strIPos(%path, "/") == -1 ? 0 : strIPos_Last(%path, "/")+1), strLen(%path));
			%indentSize = mAbs(strLen(stripChars(%childPath, "/"))-strLen(%childPath));
			%CRC        = getStringCRC(%path);
			%ChildCRC   = getStringCRC(%childPath);
			if(%childPath !$= %currentChildPath) {
				if(%gotChild[%CRC]) continue;
				%gotChild[%CRC] = 1;
				%got[%CRC] = 1;
				%pattern   = trim(%pattern SPC %path);
				continue;
			}
			if(%got[%CRC]) continue;
			%got[%CRC] = 1;
			%pattern   = trim(%pattern SPC %path);
		}
		%pattern = removeWord(%pattern, 0);
	}
}

function ScratchGui::doDirectorySelectorCallback(%this) {
	//Scratch_FileSelector.setVisible(0);
	Canvas.popDialog(ScratchFileSelector);
	%callBack = $CACHE::Scratch::DirectorySelector::CallBack;
	call(%callBack, $CACHE::Scratch::FileSelector::Path, Scratch_DirSelector_Filename.getValue());
}