function Scratch::openRightClickMenu(%callBack, %list) {
	if(Scratch_ToolTip.isVisible()) { $Scratch::TooltipSystem::closeReq = 1; }
	%this = Scratch_RightClickMenu;
	%this.clear();
	%this.add("Cancel", -1);
	for(%i=0;%i<getFieldCount(%list);%i++) %this.add(getField(%list, %i), %i);
	%this.callBack = %callBack;
	%this.resize();
	%this.setVisible(1);
	ScratchGui.pushToBack(%this);
	%this.resize(getWord(Canvas.getCursorPos(), 0), getWord(Canvas.getCursorPos(), 1), 1, 1);
	%this.forceOnAction();
}

function Scratch_RightClickMenu::onSelect(%this, %ID, %text) {
	if(strIPos(%this.callBack, "(") == -1) %this.callBack = %this.callBack @ "();";
	%funcData = Struct_funcCall(%this.callBack);
	%funcName = getRecord(%funcData, 1);
	%funcArgs = getRecord(%funcData, 2);
	%funcArgs = strReplace(%funcArgs, "\t", ",");
	if(isFunction(%funcName)) eval(%funcName @ "(" @ %funcArgs @ (%funcArgs $= "" ? %ID @ ",\"" @ %TEXT @ "\"" : "," @ %ID @ ",\"" @ %TEXT @ "\"") @ ");");
	%this.setVisible(0);
	%this.forceClose();
}

function Scratch::renderRightClickMenu() {
	%this = Scratch_RightClickMenu;
	if(Scratch_RightClickMenu.isVisible()) {
		if(ScratchGui.getObject(ScratchGui.getCount()-1).getName() !$= "Scratch_RightClickMenu") {
			%this.onSelect(-1, "Cancel");
		}
	}
}